/**
 * $RCSfile: editor_plugin_src.js,v $
 * $Revision: 1.30 $
 * $Date: 2006/02/10 16:29:37 $
 *
 * @author Moxiecode
 * @copyright Copyright  2004-2006, Moxiecode Systems AB, All rights reserved.
 */

var TinyMCE_FilePlugin = {
	
	getInfo : function() {
		return {
			longname : 'File Manager',
			author : 'Jessica Gramp',
			authorurl : 'http://jessgramp.com',
			infourl : '',
			version : tinyMCE.majorVersion + "." + tinyMCE.minorVersion
		};
	},
	
	initInstance : function(inst) {
		// You can take out plugin specific parameters
		
		var fileBrowserPopup = tinyMCE.getParam("file_browser_popup");
		var fileBrowserPopup2 = tinyMCE.getParam("file_browser_popup2");
		if(fileBrowserPopup == null || fileBrowserPopup2 == null){
			alert("In order to use the 'file' plugin you must specify the 'file_browser_popup' and 'file_browser_popup2' location in your tinymce configuration.");
			exit;
		}
	},

	getControlHTML : function(cn) {
		switch (cn) {
			case "file":
				return tinyMCE.getButtonHTML(cn, 'lang_file_desc', '{$pluginurl}/images/file.gif', 'mcefile', true);
				/*
				if(tinyMCE.isMSIE){
					return '<img id="{$editor_id}_file" src="{$pluginurl}/images/file.gif" title="{$lang_file_desc}" width="20" height="20" class="mceButtonDisabled" onmouseover="tinyMCE.switchClass(this,\'mceButtonOver\');" onmouseout="tinyMCE.restoreClass(this);" onmousedown="tinyMCE.restoreAndSwitchClass(this,\'mceButtonDown\');tinyMCE.execInstanceCommand(\'{$editor_id}\',\'mcefile\', true);" />';
				}else{
					return '<img id="{$editor_id}_file" src="{$pluginurl}/images/file.gif" title="{$lang_file_desc}" width="20" height="20" class="mceButtonNormal" onmouseover="tinyMCE.switchClass(this,\'mceButtonOver\');" onmouseout="tinyMCE.restoreClass(this);" onmousedown="tinyMCE.restoreAndSwitchClass(this,\'mceButtonDown\');tinyMCE.execInstanceCommand(\'{$editor_id}\',\'mcefile\', true);" />';
				}
				*/
		}

		return "";
	},

	execCommand : function(editor_id, element, command, user_interface, value) {
		// Handle commands
		switch (command) {
			// Remember to have the "mce" prefix for commands so they don't intersect with built in ones in the browser.
			case "mcefile":
				var fileBrowserPopup = tinyMCE.getParam("file_browser_popup");
				var fileBrowserPopup2 = tinyMCE.getParam("file_browser_popup2");
				
				var fileBrowserPopupWidth = tinyMCE.getParam("file_browser_popup_width", 720);
				var fileBrowserPopupHeight = tinyMCE.getParam("file_browser_popup_height", 470);
				
				if(fileBrowserPopup == null || fileBrowserPopup2 == null){
					alert("In order to use the 'file' plugin you must specify the 'file_browser_popup' and 'file_browser_popup2' location in your tinymce configuration.");
					exit;
				}
				var template = new Array();
				var filepath;
				var selectedFile = tinyMCE.selectedInstance.getFocusElement();

				parentATag = tinyMCE.getParentElement(selectedFile);
				if(parentATag.href != null){
					if(parentATag.href.indexOf('content/files/') > 0){
						filepath = fileBrowserPopup+'?href=' + parentATag.href;
						if(parentATag.title != null){
							filepath += '&title=' + parentATag.title;
						}
						if(parentATag.target != null){
							filepath += '&target=' + parentATag.target;
						}
						fileBrowserPopup = filepath;
					}else{
						alert("Please remove the link ("+parentATag.href+") from the selected item before continuing.");	
						exit;
					}
				}else{
					fileBrowserPopup = fileBrowserPopup2;
				}
				// Show UI/Popup
				if (user_interface) {
					// Open a popup window and send in some custom data in a window argument
					var file = new Array();
					file['file'] = fileBrowserPopup; // Relative to theme
					file['width'] = fileBrowserPopupWidth;
					file['height'] = fileBrowserPopupHeight;
	
					tinyMCE.openWindow(file, {editor_id : editor_id, resizable : "yes", scrollbars : "yes"});
					
					// Let TinyMCE know that something was modified
					tinyMCE.triggerNodeChange(false);
				} else {
					// Do a command this gets called from the file popup
					//alert("execCommand: mcefile gets called from popup.");
					//tinyMCE.execInstanceCommand(editor_id, 'mceInsertContent', false, value);
				}
	
				return true;
		}

		// Pass to next handler in chain
		return false;
	}

};
tinyMCE.addPlugin("file", TinyMCE_FilePlugin);
tinyMCE.addToLang('',{file_desc : 'Insert/edit file'});