/**
 * $RCSfile: editor_plugin_src.js,v $
 * $Revision: 1.30 $
 * $Date: 2006/02/10 16:29:37 $
 *
 * @author Moxiecode
 * @copyright Copyright  2004-2006, Moxiecode Systems AB, All rights reserved.
 */

/* Import plugin specific language pack */
//tinyMCE.importPluginLanguagePack('file', 'en');

var TinyMCE_FilePlugin = {
	getInfo : function() {
		return {
			longname : 'File Manager',
			author : 'Jessica Gramp',
			authorurl : 'http://jessgramp.com',
			infourl : '',
			version : tinyMCE.majorVersion + "." + tinyMCE.minorVersion
		};
	},

	getControlHTML : function(cn) {
		switch (cn) {
			case "file":
				return tinyMCE.getButtonHTML(cn, 'lang_file_desc', '{$pluginurl}/images/file.gif', 'file');
		}

		return "";
	},

	execCommand : function(editor_id, element, command, user_interface, value) {
	// Handle commands
	switch (command) {
		// Remember to have the "mce" prefix for commands so they don't intersect with built in ones in the browser.
		case "mcefile":
		var fileBrowserPopup = tinyMCE.getParam("file_browser_popup");
		var fileBrowserPopup2 = tinyMCE.getParam("file_browser_popup2");
		
		var fileBrowserPopupWidth = tinyMCE.getParam("file_browser_popup_width", 720);
		var fileBrowserPopupHeight = tinyMCE.getParam("file_browser_popup_height", 470);
		
		if(fileBrowserPopup == null){
			alert("You must specify the 'file_browser_popup' location in your tinymce configuration");
			exit;
		}
		var template = new Array();
		var filepath;
		var selectedFile = tinyMCE.selectedInstance.getFocusElement();
		if(selectedFile.parentNode.href != null){
			filepath = fileBrowserPopup+'?href=' + selectedFile.parentNode.href;
			if(selectedFile.parentNode.title != null){
				filepath += '&title=' + selectedFile.parentNode.title;
			}
			if(selectedFile.parentNode.target != null){
				filepath += '&target=' + selectedFile.parentNode.target;
			}
			fileBrowserPopup = filepath;
		}else{
			fileBrowserPopup = fileBrowserPopup2;
		}
			// Show UI/Popup
			if (user_interface) {
				// Open a popup window and send in some custom data in a window argument
				var file = new Array();

				file['file'] = fileBrowserPopup; // Relative to theme
				file['width'] = fileBrowserPopupWidth;
				file['height'] = fileBrowserPopupHeight;

				tinyMCE.openWindow(file, {editor_id : editor_id, resizable : "yes", scrollbars : "yes"});

				// Let TinyMCE know that something was modified
				tinyMCE.triggerNodeChange(false);
			} else {
				// Do a command this gets called from the file popup
				//alert("execCommand: mcefile gets called from popup.");
			}

			return true;
	}

	// Pass to next handler in chain
	return false;
	},

	cleanup : function(type, content) {
		switch (type) {
			case "insert_to_editor_dom":
				var imgs = content.getElementsByTagName("img");
				for (var i=0; i<imgs.length; i++) {
					var onmouseover = tinyMCE.cleanupEventStr(tinyMCE.getAttrib(imgs[i], 'onmouseover'));
					var onmouseout = tinyMCE.cleanupEventStr(tinyMCE.getAttrib(imgs[i], 'onmouseout'));

					if ((src = this._getImageSrc(onmouseover)) != "") {
						if (tinyMCE.getParam('convert_urls'))
							src = tinyMCE.convertRelativeToAbsoluteURL(tinyMCE.settings['base_href'], src);

						imgs[i].setAttribute('onmouseover', "this.src='" + src + "';");
					}

					if ((src = this._getImageSrc(onmouseout)) != "") {
						if (tinyMCE.getParam('convert_urls'))
							src = tinyMCE.convertRelativeToAbsoluteURL(tinyMCE.settings['base_href'], src);

						imgs[i].setAttribute('onmouseout', "this.src='" + src + "';");
					}
				}
				break;

			case "get_from_editor_dom":
				var imgs = content.getElementsByTagName("img");
				for (var i=0; i<imgs.length; i++) {
					var onmouseover = tinyMCE.cleanupEventStr(tinyMCE.getAttrib(imgs[i], 'onmouseover'));
					var onmouseout = tinyMCE.cleanupEventStr(tinyMCE.getAttrib(imgs[i], 'onmouseout'));

					if ((src = this._getImageSrc(onmouseover)) != "") {
						if (tinyMCE.getParam('convert_urls'))
							src = eval(tinyMCE.settings['urlconverter_callback'] + "(src, null, true);");

						imgs[i].setAttribute('onmouseover', "this.src='" + src + "';");
					}

					if ((src = this._getImageSrc(onmouseout)) != "") {
						if (tinyMCE.getParam('convert_urls'))
							src = eval(tinyMCE.settings['urlconverter_callback'] + "(src, null, true);");

						imgs[i].setAttribute('onmouseout', "this.src='" + src + "';");
					}
				}
				break;
		}

		return content;
	},

	handleNodeChange : function(editor_id, node, undo_index, undo_levels, visual_aid, any_selection) {
		// any_selection ONLY SEEMS TO HAVE A VALUE IN IE
		 if(tinyMCE.selectedInstance.getSelectedText() != ""){
			tinyMCE.switchClassSticky(editor_id + '_file', 'mceButtonNormal');
		}else{
			tinyMCE.switchClassSticky(editor_id + '_file', 'mceButtonDisabled');
		}
		return true;
	},

tinyMCE.addPlugin("file", TinyMCE_FilePlugin);
